'
'djbPf`[W@NiMH CHG_14    2022.01.27    JE1UCI
'------------------------------------------------------------------------------
$regfile = "attiny861.dat"

$crystal = 8000000

$hwstack = 32
$swstack = 4
$framesize = 16

Config Porta = &B00000011                                   '0=INPUT   1=OUTPUT
Config Portb = &B11001111                                   '0=INPUT   1=OUTPUT
Porta = &B00000000
Portb = &B00110000

Config Scl = Porta.1
Config Sda = Porta.0
Config I2cdelay = 5
Config Adc = Single , Prescaler = Auto , Reference = Internal_2.56_extcap

Dim Adout5 As Word
Dim Adout6 As Word
Dim Volt As Single
Dim Ondo As Single
Dim V_total As Long
Dim O_total As Long
Dim Tempa As Word
Dim A As String * 9
Dim Vend As Single
Dim Hour As Byte
Dim Minute As Byte
Dim Second As Byte
Dim Chg_on As Bit
Dim Adccycle As Word


Declare Sub i2cs(byval B As Byte)

'------------------------------------------------------------------------------
Dataset:
   Start Adc
   I2cinit
   Cls
   Waitms 50
   Gosub Aqm0802_set
   Gosub Chg_reset
   Adccycle = 200

'------------------------------------------------------------------------------
Main:
   If Pinb.5 = 0 Then
      Gosub Chg_reset
         End If

   Tempa = 0
   V_total = 0
   O_total = 0
   Do
      Tempa = Tempa + 1
      Adout5 = Getadc(3)
      O_total = O_total + Adout5
      Adout6 = Getadc(6)
      V_total = V_total + Adout6
         Loop Until Tempa = Adccycle
'             Tempa = 0
Main_dsp_ondo:
   Ondo = O_total / Adccycle
   Ondo = Ondo * 0.25
   Gosub Dsp_ondo

Main_dsp_volt:
   Volt = V_total / Adccycle
   Volt = Volt * 0.00800782
   Gosub Dsp_volt

   If Chg_on = 1 Then
      Goto Main_chg_end
         End If

Main_vend_ctl:
   Vend = Ondo * 0.0073
   Vend = 4.4688 - Vend
   Select Case Volt
'      Case Is < 4.35 : Set Portb.6
      Case Is >= Vend : Chg_on = 1
         End Select

Main_time_ctl:
   Second = Second + 1
   If Second = 83 Then                                      '83ݒ60bƂȂ
      Minute = Minute + 1
      Second = 0
      If Minute = 60 Then
         Hour = Hour + 1
         Minute = 0
            End If
      Gosub Dsp_time
         End If
   If Hour = 15 Then
      Chg_on = 1
         End If
   Goto Main_end

Main_chg_end:
   Reset Portb.6

Main_end:
   Goto Main

'------------------------------------------------------------------------------
'ȉTu[`
'------------------------------------------------------------------------------
Aqm0802_set:
   I2cstart
   Call I2cs(&H38)
   Waitus 27
   Call I2cs(&H39)
   Waitus 27
   Call I2cs(&H14)
   Waitus 27
   Call I2cs(&H70)
   Waitus 27
   Call I2cs(&H56)
   Waitus 27
   Call I2cs(&H6c)
   Waitus 27
   Call I2cs(&H38)
   Waitus 27
   Call I2cs(&H0c)
   Waitus 27
   Call I2cs(&H01)
   Waitms 2
   Return

'------------------------------------------------------------------------------
Dsp_time:
   Select Case Minute
      Case Is < 10 : Gosub Dsp_time1
      Case Is >= 10 : Gosub Dsp_time2
      End Select

   Select Case Hour
      Case Is < 10 : Gosub Dsp_time4
      Case Is >= 10 : Gosub Dsp_time3
      End Select
   Return

'---------------------
Dsp_time1:
   A = "@ "
   Call I2cs(&Hc6)
   I2csend &H7C , A , 2
   A = "@" + Str(minute)
   Call I2cs(&Hc7)
   I2csend &H7C , A , 2
   Return

'---------------------
Dsp_time2:
   A = "@" + Str(minute)
   Call I2cs(&Hc6)
   I2csend &H7C , A , 3
   Return

'---------------------
Dsp_time3:
   A = "@" + Str(hour)
   Call I2cs(&H86)
   I2csend &H7C , A , 3
   Return

'---------------------
Dsp_time4:
   A = "@" + Str(hour)
   Call I2cs(&H87)
   I2csend &H7C , A , 2
   Return

'------------------------------------------------------------------------------
Dsp_volt:
   A = "@" + Str(volt)
   Call I2cs(&H80)
   I2csend &H7C , A , 6
   A = "@V"
   Call I2cs(&H85)
   I2csend &H7C , A , 2
   Return

'------------------------------------------------------------------------------
Dsp_ondo:
   A = "@" + Str(ondo)
   Call I2cs(&Hc0)
   I2csend &H7C , A , 5
   A = "@C"
   Call I2cs(&Hc4)
   I2csend &H7C , A , 2
   Return

'-----------------------
Sub I2cs(byval B As Byte)
   I2cstart
   I2cwbyte &H7C
   I2cwbyte &H80
   I2cwbyte B
   I2cstop
   End Sub

 '------------------------------------------------------------------------------
Chg_reset:
   Hour = 0
   Minute = 0
   Second = 0
   Chg_on = 0
   Set Portb.6
   Gosub Dsp_time
   Return

'------------------------------------------------------------------------------
   End